package org.yaoqiang.bpmn.editor.io.graphml;

/**
 * GraphMLConstants
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class GraphMLConstants {

	public static String CONFIGURATION = "configuration";
	public static String CONFIGURATION_EVENT = "com.yworks.bpmn.Event.withShadow";
	public static String CONFIGURATION_ACTIVITY = "com.yworks.bpmn.Activity.withShadow";
	public static String CONFIGURATION_GATEWAY = "com.yworks.bpmn.Gateway.withShadow";
	public static String CONFIGURATION_ARTIFACT = "com.yworks.bpmn.Artifact.withShadow";
	public static String CONFIGURATION_POOL = "com.yworks.bpmn.Pool";

	public static String BPMN_TYPE = "com.yworks.bpmn.type";
	
	public static String EVENT_TYPE_PLAIN = "EVENT_TYPE_PLAIN";
	public static String EVENT_TYPE_MESSAGE = "EVENT_TYPE_MESSAGE";
	public static String EVENT_TYPE_TIMER = "EVENT_TYPE_TIMER";
	public static String EVENT_TYPE_ERROR = "EVENT_TYPE_ERROR";
	public static String EVENT_TYPE_CANCEL = "EVENT_TYPE_CANCEL";
	public static String EVENT_TYPE_COMPENSATION = "EVENT_TYPE_COMPENSATION";
	public static String EVENT_TYPE_CONDITIONAL = "EVENT_TYPE_CONDITIONAL";
	public static String EVENT_TYPE_SIGNAL = "EVENT_TYPE_SIGNAL";
	public static String EVENT_TYPE_MULTIPLE = "EVENT_TYPE_MULTIPLE";
	public static String EVENT_TYPE_LINK = "EVENT_TYPE_LINK";
	public static String EVENT_TYPE_TERMINATE = "EVENT_TYPE_TERMINATE";
	
	public static String ARTIFACT_TYPE_DATA_OBJECT = "ARTIFACT_TYPE_DATA_OBJECT";
	public static String ARTIFACT_TYPE_ANNOTATION = "ARTIFACT_TYPE_ANNOTATION";
	public static String ARTIFACT_TYPE_GROUP = "ARTIFACT_TYPE_GROUP";	
	
	public static String CONNECTION_TYPE_SEQUENCE_FLOW = "CONNECTION_TYPE_SEQUENCE_FLOW";
	public static String CONNECTION_TYPE_CONDITIONAL_FLOW = "CONNECTION_TYPE_CONDITIONAL_FLOW";
	public static String CONNECTION_TYPE_DEFAULT_FLOW = "CONNECTION_TYPE_DEFAULT_FLOW";
	public static String CONNECTION_TYPE_ASSOCIATION = "CONNECTION_TYPE_ASSOCIATION";
	public static String CONNECTION_TYPE_DIRECTED_ASSOCIATION = "CONNECTION_TYPE_DIRECTED_ASSOCIATION";
	public static String CONNECTION_TYPE_MESSAGE_FLOW = "CONNECTION_TYPE_MESSAGE_FLOW";
	
	public static String GATEWAY_TYPE_PLAIN = "GATEWAY_TYPE_PLAIN";
	public static String GATEWAY_TYPE_DATA_BASED_EXCLUSIVE = "GATEWAY_TYPE_DATA_BASED_EXCLUSIVE";
	public static String GATEWAY_TYPE_EVENT_BASED_EXCLUSIVE = "GATEWAY_TYPE_EVENT_BASED_EXCLUSIVE";
	public static String GATEWAY_TYPE_PARALLEL = "GATEWAY_TYPE_PARALLEL";
	public static String GATEWAY_TYPE_INCLUSIVE = "GATEWAY_TYPE_INCLUSIVE";
	public static String GATEWAY_TYPE_COMPLEX = "GATEWAY_TYPE_COMPLEX";
	
	public static String ACTIVITY_TYPE_STATELESS_TASK_PLAIN = "ACTIVITY_TYPE_STATELESS_TASK_PLAIN";
	public static String ACTIVITY_TYPE_STATELESS_TASK_AD_HOC = "ACTIVITY_TYPE_STATELESS_TASK_AD_HOC";
	public static String ACTIVITY_TYPE_STATELESS_TASK_LOOP = "ACTIVITY_TYPE_STATELESS_TASK_LOOP";
	public static String ACTIVITY_TYPE_STATELESS_TASK_MULTIPLE = "ACTIVITY_TYPE_STATELESS_TASK_MULTIPLE";
	
	public static String ACTIVITY_TYPE_TASK_PLAIN = "ACTIVITY_TYPE_TASK_PLAIN";
	public static String ACTIVITY_TYPE_TASK_LOOP = "ACTIVITY_TYPE_TASK_LOOP";
	public static String ACTIVITY_TYPE_TASK_AD_HOC = "ACTIVITY_TYPE_TASK_AD_HOC";
	public static String ACTIVITY_TYPE_TASK_MULTIPLE = "ACTIVITY_TYPE_TASK_MULTIPLE";
	public static String ACTIVITY_TYPE_SUBPROCESS_PLAIN = "ACTIVITY_TYPE_SUBPROCESS_PLAIN";
	public static String ACTIVITY_TYPE_SUBPROCESS_AD_HOC = "ACTIVITY_TYPE_SUBPROCESS_AD_HOC";
	public static String ACTIVITY_TYPE_SUBPROCESS_LOOP = "ACTIVITY_TYPE_SUBPROCESS_LOOP";
	public static String ACTIVITY_TYPE_SUBPROCESS_MULTIPLE = "ACTIVITY_TYPE_SUBPROCESS_MULTIPLE";
	
	public static String EVENT_CHARACTERISTIC = "com.yworks.bpmn.characteristic";
	public static String EVENT_CHARACTERISTIC_START = "EVENT_CHARACTERISTIC_START";
	public static String EVENT_CHARACTERISTIC_INTERMEDIATE_CATCHING = "EVENT_CHARACTERISTIC_INTERMEDIATE_CATCHING";
	public static String EVENT_CHARACTERISTIC_INTERMEDIATE_THROWING = "EVENT_CHARACTERISTIC_INTERMEDIATE_THROWING";
	public static String EVENT_CHARACTERISTIC_END = "EVENT_CHARACTERISTIC_END";
	
	public static String FOLDER_TYPE = "yfiles.foldertype";
	public static String FOLDER_TYPE_FOLDER = "folder";
	public static String FOLDER_TYPE_GROUP = "group";

	public static String PROXY_AUTO_BOUNDS_NODE = "ProxyAutoBoundsNode";
	
	public static String REALIZERS = "Realizers";

	public static String ACTIVE = "active";

	public static String TABLE_NODE = "TableNode";

	public static String GENERIC_GROUP_NODE = "GenericGroupNode";
	
	public static String GENERIC_NODE = "GenericNode";

	public static String GENERIC_EDGE = "GenericEdge";
	
	public static String NODE_LABEL = "NodeLabel";
	
	public static String EDGE_LABEL = "EdgeLabel";

	public static String STYLE_PROPERTIES = "StyleProperties";

	public static String PROPERTY = "Property";

	public static String NAME = "name";

	public static String VALUE = "value";

	public static String HEIGHT = "height";

	public static String WIDTH = "width";

	public static String X = "x";

	public static String Y = "y";

	public static String YWORKS = "y:";

	public static String GEOMETRY = "Geometry";
	
	public static String EDGE_SOURCE = "source";

	public static String EDGE_TARGET = "target";

	public static String PATH = "Path";

	public static String POINT = "Point";

	public static String ID = "id";

	public static String KEY_FOR = "for";

	public static String KEY_NAME = "attr.name";

	public static String KEY_TYPE = "attr.type";

	public static String GRAPH = "graph";

	public static String GRAPHML = "graphml";

	public static String NODE = "node";

	public static String EDGE = "edge";

	public static String HYPEREDGE = "hyperedge";

	public static String PORT = "port";

	public static String ENDPOINT = "endpoint";

	public static String KEY = "key";

	public static String DATA = "data";

	public static String ALL = "all";

	public static String EDGE_DIRECTED = "directed";

	public static String EDGE_UNDIRECTED = "undirected";

	public static String EDGE_DEFAULT = "edgedefault";

	public static String PORT_NAME = "name";

	public static String FILL = "Fill";

	public static String KEY_NODE_ID = "d0";

	public static String KEY_NODE_NAME = "nodeData";

	public static String KEY_EDGE_ID = "d1";

	public static String KEY_EDGE_NAME = "edgeData";

	public static String STYLE = "Style";

	public static String SHAPE = "Shape";

	public static String TYPE = "type";
	
	public static String TEXT = "text";

	public static String PROPERTIES = "properties";

	public static String SOURCETARGET = "SourceTarget";
}
