package org.yaoqiang.bpmn.editor.io.graphml;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * GraphMLNode
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class GraphMLNode {

	private String nodeId;

	private GraphMLData nodeData;

	private GraphMLGraph graph;

	public GraphMLNode(Element nodeElement) {
		this.nodeId = nodeElement.getAttribute(GraphMLConstants.ID).replaceAll(":", "_");

		NodeList dataList = nodeElement.getElementsByTagName(GraphMLConstants.DATA);
		if (dataList.getLength() > 0) {
			Element dataElement = (Element) dataList.item(0);
			nodeData = new GraphMLData(dataElement);
		}

		NodeList graphList = nodeElement.getElementsByTagName(GraphMLConstants.GRAPH);
		if (graphList.getLength() > 0) {
			Element graphElement = (Element) graphList.item(0);
			graph = new GraphMLGraph(graphElement);
		}
	}

	public String getNodeId() {
		return nodeId;
	}

	public void setNodeId(String nodeId) {
		this.nodeId = nodeId;
	}

	public GraphMLData getNodeData() {
		return nodeData;
	}

	public GraphMLGraph getNodeGraph() {
		return graph;
	}

}
