package org.yaoqiang.bpmn.model.elements.activities;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLComplexElement;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;

/**
 * ResourceRole
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ResourceRole extends BaseElement {

	public ResourceRole(XMLElement parent) {
		super(parent, "resourceRole");
	}

	public ResourceRole(XMLElement parent, String name) {
		super(parent, name);
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		ResourceAssignTypes refResourceTypes = new ResourceAssignTypes(this);

		super.fillStructure();
		add(attrName);
		add(refResourceTypes);
	}

	public final String getName() {
		return get("name").toValue();
	}

	public final String getResourceRef() {
		if (getResourceAssignTypes().getChoosen().toName().equals("parameterAssignment")) {
			return ((XMLComplexElement) getResourceAssignTypes().getChoosen()).get("resourceRef").toValue();
		}
		return "";
	}

	public final ResourceAssignTypes getResourceAssignTypes() {
		return (ResourceAssignTypes) get("ResourceAssignTypes");
	}

	public final void setName(String name) {
		set("name", name);
	}

}
