package org.yaoqiang.bpmn.model.elements.core.common;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;

/**
 * ResourceParameter
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ResourceParameter extends BaseElement {

	public ResourceParameter(ResourceParameters parent) {
		super(parent, "resourceParameter");
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		XMLAttribute attrType = new XMLAttribute(this, "type");
		XMLAttribute attrIsRequired = new XMLAttribute(this, "isRequired");

		super.fillStructure();
		add(attrName);
		add(attrType);
		add(attrIsRequired);
	}

	public ResourceParameters getParent() {
		return (ResourceParameters) parent;
	}

	public final String getName() {
		return get("name").toValue();
	}
}
