package org.yaoqiang.bpmn.model.elements.core.infrastructure;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLComplexElement;
import org.yaoqiang.bpmn.model.elements.core.common.ItemDefinition;

/**
 * Import
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class Import extends XMLComplexElement {

	public Import(Imports parent) {
		super(parent, "import");
	}

	public Import(ItemDefinition parent) {
		super(parent, "import");
	}
	
	protected void fillStructure() {
		XMLAttribute attrImportType = new XMLAttribute(this, "importType");
		XMLAttribute attrLocation = new XMLAttribute(this, "location");
		XMLAttribute attrNamespace = new XMLAttribute(this, "namespace");

		add(attrImportType);
		add(attrLocation);
		add(attrNamespace);
	}

	public final String getImportType() {
		return get("importType").toValue();
	}
	
	public final String getLocation() {
		return get("location").toValue();
	}
	
	public final String getNamespace() {
		return get("namespace").toValue();
	}
	
	public final void setImportType(String importType) {
		set("importType", importType);
	}
	
	public final void setNamespace(String namespace) {
		set("namespace", namespace);
	}
	
}
