package org.yaoqiang.bpmn.model.elements.gateways;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.core.common.FlowElements;
import org.yaoqiang.bpmn.model.elements.core.common.SequenceFlow;

/**
 * ExclusiveGateway
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ExclusiveGateway extends Gateway {

	public ExclusiveGateway(FlowElements parent) {
		super(parent, "exclusiveGateway");
	}

	protected void fillStructure() {
		XMLAttribute attrDefault = new XMLAttribute(this, "default");

		super.fillStructure();
		add(attrDefault);
	}

	public SequenceFlow getDefaultSequenceFlow() {
		return (SequenceFlow) getParent().getFlowElement(get("default").toValue());
	}
}
